-- ##### TerraLAB - www.terralab.ufop.br
-- Computer Science Departament, Federal Univeristy of Ouro Preto
-- TerraME Prey-Predator dynamic model based on differental equations
-- Tiago Garcia de Senna Carneiro - 07/2012
-------------
-- Discrete simulators.
-- Integration increment (dt) and simulation time step (t) are the same
-------------


--#PARAMETERS
birthPreyRate = 0.2
predationRate = 0.01 -- death prey rate
birthPredatorPerPreyRate = 0.01 -- birth predator rate
deathPredatorRate =  0.1 -- death prey rate


--#BEHAVIORAL MODEL
ag = Agent{ preys = 100, predators = 10 }

--#OBSERVERS
chartObserver = Observer{ subject = ag, type = "chart", attributes={"preys","predators"}, 
				title="Preys x Time", curveLabels={"preys", "predators"}, yLabel="#preys", xLabel="timer" }

--#RULES
for t = 0, 200, 0.03125 do -- try for until 1 (with string) or 200 (no string)

    -- >>>>> ATTENTION <<<<<<<<<<<<<<<
	-- The calculations made by this code does not work, because although prey and predator systems are
	-- coupled, the equations implement them in a wrong way - decoupled. Prey system is simulated first
	--- and then, the predators system is simulated. Therefore, model implementation propagates error.
	

	--str = ""
	ag.preys = 	d{ function( t, q )  
							--str = str..q..", "
							return q*birthPreyRate - q*ag.predators*predationRate 
						end , ag.preys, 0, 0.03125, 0.03125 }
	
	ag.predators =	d{ function( t, q ) 
								--str = str..q
								return q*ag.preys*birthPredatorPerPreyRate - q*deathPredatorRate
							end , ag.predators, 0, 0.03125, 0.03125 }
	--print(str)

	ag:notify(t)
end
print( ag.preys, ag.predators )

