-- ##### TerraLAB - www.terralab.ufop.br
-- Computer Science Departament, Federal Univeristy of Ouro Preto
-- TerraME Prey-Predator dynamic model based on differental equations
-- Tiago Garcia de Senna Carneiro - 07/2012
-------------
-- You just need loops to simulate continuous systems if you want to observe them.
-- However, the implementation could be trick!
-------------

--#PARAMETERS
birthPreyRate = 0.2
predationRate = 0.01 -- death prey rate
birthPredatorPerPreyRate = 0.01 -- birth predator rate
deathPredatorRate =  0.1 -- death prey rate


--#BEHAVIORAL MODEL
ag = Agent{ preys = 100, predators = 10 }

--#OBSERVERS
chartObserver = Observer{ subject = ag, type = "chart",attributes={"preys","predators"}, 
				title="Preys x Time", curveLabels={"preys", "predators"}, yLabel="#preys", xLabel="time" }

	
--#Integration Method (please, vary it: "integrationHeun", "integrationRungeKutta" and 0.25, "integrationEuler" and 0.25)
INTEGRATION_METHOD =  integrationEuler

--#RULES
ag.preys, ag.predators = d{
	{ 	
		function( t, q )
			--ag:notify(t) -- try to uncomment this line to show the observer will and should not work properly (IT IS NOT A BUG)
			return q[1]*birthPreyRate - q[1]*q[2]*predationRate 
		end , 
		
		function( t, q ) 
			return q[2]*q[1]*birthPredatorPerPreyRate - q[2]*deathPredatorRate
		end
	},
	{ ag.preys, ag.predators }, 
	0, 2000 , 0.03125 -- try to use + 0.03125 in the upper limit (2000 + 0.03125) showing that there are some tricks in implementing continuous simulations, which TerraME solves for you.
	                         -- compare the new result with the outcome of the model classic_prey_predator_v3.lua   
}
	
print("Model outcome: ", ag.preys, ag.predators )