-- RAIN DRAINAGE MODELS
-- (C) 2010 INPE AND UFOP

print("default value of TerraME numerical integration increment")
print("DELTA", DELTA)

-- model parameters
C = 2 -- rain/t
K = 0.4 -- flow coefficient
dt = 1

-- global variables
q = 0
input = 0
output = 0

print("modelers can choose among different integration methods")
-- try to uncomment each of lines below
--INTEGRATION_METHOD = integrationEuler
--INTEGRATION_METHOD = integrationHeun
--INTEGRATION_METHOD = integrationRungeKutta

print("modelers can also implement their ownn integration method and extends TerraME")
print("integrationMethod",INTEGRATION_METHOD)

print("ALTERNATIVE 1: First implementations of model rules (THE MOST LEGIBLE)")
q = 0
q = integrate{
	equation = function (t, v)
	    --print("debug:", qq) 
		return C - K * v 
	end,
	method = "euler",
	initial = q,
	a = 0,
	b = 6,
	step = dt
}
print(q)

print("ALTERNATIVE 2: Second implementation of models rules (THE CONCISE)")
q  = 0
q = d{ function (t, qq) return C - K*qq end, q, 0, 6, dt }
print(q)

print("Please, press <ENTER> to quit.")
io.flush()
io.read()

